
let auto1() =
   open_graph "auto1.lp" 0. 40. 0. 40. 40. 40.;
   let s1 = draw_vertex 10. 30. 5. "$1$"
   and s2 = draw_vertex 30. 30. 5. "$2$"
   and s3 = draw_vertex 10. 10. 5. "$3$"
   and s4 = draw_vertex 30. 10. 5. "$4$" in
   draw_arc 1 2. s1 s2 G "$a$";
   draw_arc 1 2. s2 s1 G "$a$";
   draw_arc 1 2. s3 s4 G "$a$";
   draw_arc 1 2. s4 s3 G "$a$";
   draw_arc 1 2. s1 s3 G "$b$";
   draw_arc 1 2. s3 s1 G "$b$";
   draw_arc 1 2. s2 s4 G "$b$";
   draw_arc 1 2. s4 s2 G "$b$";
   draw_in 5. (-.pi) s1;
   draw_out 5. (pi/.2.) s1;
   close_graph();;

let auto2() =
   open_graph "auto2.lp" 0. 50. 0. 20. 50. 20.;
   let s0 = draw_vertex 10. 10. 5. "$0$"
   and s1 = draw_vertex 20. 10. 5. "$1$"
   and s2 = draw_vertex 30. 10. 5. "$2$"
   and s3 = draw_vertex 40. 10. 5. "$3$" in
   draw_arc 1 0. s0 s1 G "$a$";
   draw_arc 1 0. s1 s2 G "$b$";
   draw_arc 1 0. s2 s3 G "$a$";
   draw_arc 1 3. s2 s0 G "$b$";
   draw_in 5. pi s0;
   draw_out 5. 0. s3;
   draw_loop 1 3. (pi/.2.) s0 D "$b$";
   draw_loop 1 3. (pi/.2.) s1 D "$a$";
   draw_loop 1 3. (pi/.2.) s3 D "$a,b$";
   close_graph();;

let arbre1() =
   let diametre = 5.
   and marge = 1. in
   let struct s =
         {
         elementgraphique = s;
         fonctionnoeud = (fun e x y ->
            if e = ""
               then draw_thickdot x y
               else draw_shadedcircle x y diametre ("$"^e^"$") 0.);
         fonctionarc = (fun _ _ -> draw_line);
         ecarthorizontal = 6.5;
         ecartvertical = 7.;
         largeurnoeud = diametre +. marge;
         hauteurnoeud = diametre +. marge
         } in
   let draw s = draw_structuregraphique (struct s)
   and dims s = dimensions_structuregraphique (struct s) in
   let arbre_exemple =
      arbre_of_string
         "1(2(3(4()5(6()7(8()9(10()11())))))12(13(14()15()16()17())18()19()))"
   and foret_exemple = foret_of_string "(((()(()(()(()())))))((()()()())()()))"
   and arbrebinaire_exemple =
      arbrebinaire_of_string ("0(1(2(()3(()5()))4(2(6(()8(()9()))())()))1(2(3"^
                                 "(4()())())2(3(4(5(6(7()())())())())())))") in
   let l1,h1 = dims (Arbre arbre_exemple)
   and l2,h2 = dims (Foret foret_exemple)
   and l3,h3 = dims (Arbrebinaire arbrebinaire_exemple) in
   let largeur = l1 +. l2 +. l3
   and hauteur = max_float (max_float h1 h2) h3 in
   open_graph "arbre1.lp" 0. largeur 0. hauteur largeur hauteur;
   draw_box (largeur /. 2.) (hauteur /. 2.) largeur hauteur "";
   draw_line l1 0. l1 hauteur;
   draw_line (l1 +. l2) 0. (l1 +. l2) hauteur;
   draw (Arbre arbre_exemple) 0. hauteur;
   draw (Foret foret_exemple) l1 hauteur;
   draw (Arbrebinaire arbrebinaire_exemple) (l1 +. l2) hauteur;
   close_graph();;

#open"random";;

init 314159;;

let arbre2 n =
   let rec ast = function
      0 -> Nil |
      n -> let k = int n in Noeud(ast k,"",ast(n-1-k)) in
   let a = ast n in
   let e =
      {
      elementgraphique = Arbrebinaire a;
      fonctionnoeud = (function _ -> draw_thickdot);
      fonctionarc = (fun _ _ -> draw_line);
      ecarthorizontal = 120. /. (largeur_arbrebinaire a);
      ecartvertical = 2.;
      largeurnoeud = 1.;
      hauteurnoeud = 1.
      } in
   let l,h = dimensions_structuregraphique e in
   open_graph "arbre2.lp" 0. l 0. h l h;
   draw_structuregraphique e 0. h;
   close_graph();;

let essai_draw_circlearc1() =
   open_graph "essai.lp" 0. 40. 0. 40. 40. 40.;
   draw_circle 20. 20. 30. "";
   for i = 0 to 15 do
      let i = float_of_int i in
      let t = 2.*.pi*.i/.15. in
      let c = i*.cos t
      and s = i*.sin t in
      draw_line 20. 20. (20. +. c) (20.+.s);
      draw_circlearc 20. 20. (2.*.i) t (t+.2.*.pi/.15.)
   done;
   close_graph();;


essai_draw_circlearc1();;

let essai_draw_circlearc2() =
   open_graph "essai.lp" 0. 40. 0. 40. 40. 40.;
   let t = pi/.20.
   and x,y = -.100.,20. in
   draw_line x y (x +.120.*.cos t)  (y-.120.*.sin t);
   draw_line x y (x +.120.*.cos t)  (y+.120.*.sin t);
   draw_circlearc x y 240. (-.t) t;
   close_graph();;


essai_draw_circlearc2();;

let essai_draw_arc() =
   graphics__open_graph"";
   let pi=acos(-.1.) in
   let t =9
   and tr = pi/.20. in
   let s = size_y() in
   let x = -(s*5)/2
   and y= s/2 in
   let r = s*6/2 in
   let rr = float_of_int r in
   moveto x y;
   lineto(x+int_of_float(rr*.cos tr))(y+int_of_float(rr*.sin tr));
   moveto x y;
   lineto(x+int_of_float(rr*.cos tr))(y-int_of_float(rr*.sin tr));
   graphics__draw_arc x y r r (-t) t;;

essai_draw_arc();;

